/* @tools - pattern matching (obsolete)
 */
#include <stdio.h>
#include <ctype.h>
#include <macros.h>
#include "tools.h"

char *amatch(char *lin, TOKEN *pat, char *boln)
	{
	register char *bocl, *rval, *strstart;
	
	if (pat == NULL)
		return NULL;
	strstart = lin;
	while (pat)
		{
		if (pat->tok == CLOSURE && pat->next)
			{
			pat = pat->next;
			bocl = lin;
			while (*lin && omatch(&lin, pat, boln))
				;
			if (pat = pat->next)
				{
				while (bocl <= lin)
					{
					if (rval = amatch(lin, pat, boln))
						return rval;
					else
						--lin;
					}
				return NULL;
				}
			}
		else if (omatch(&lin, pat, boln))
			pat = pat->next;
		else
			return NULL;
		}
	--lin;
	return max(strstart, lin);
	}

#ifdef DEBUG1
delete(int ch, register char *str)
	{
	ch &= 0xff;
	while (*str && *str != ch)
		str++;
	while (*str)
		{
		*str = *(str + 1);
		str++;
		}
	}
#endif

setbit(int c, char field[])
	{
	field[(c & 0x7f) >>3] |= 1 << (c & 0x07);
	}

testbit(int c, char field[])
	{
	return field[(c & 0x7f) >>3] & (1 << (c & 0x07));
	}

char *dodash(int delim, char *src, char *map)
	{
	register int first, last;
	char *start;

	start = src;
	while (*src && *src != delim)
		{
		if (*src != '-')
			setbit(esc(&src), map);
		else if (src == start || *(src + 1) == delim)
			setbit('-', map);
		else
			{
			src++;
			if (*src < *(src - 2))
				{	
				first = *src;
				last = *(src - 2);
				}
			else
				{
				first = *(src - 2);
				last = *src;
				}
			while (++first <= last)
				setbit(first, map);
			src++;
			}
		}
	if (*src != delim)
		return NULL;
	else
		return src;
	}

int esc(char **s)
	{
	register int rval;

	if (**s != ESCAPE)
		rval = *((*s)++);
	else
		{
		(*s)++;
		switch (toupper(**s))
			{
		case '\0': rval = ESCAPE; break;
		case 'B': rval = '\b'; break;
		case 'F': rval = '\f'; break;
		case 'N': rval = '\n'; break;
		case 'R': rval = '\r'; break;
		case 'S': rval = ' '; break;
		case 'T': rval = '\t'; break;
		default: rval = **s; break;
			}
		(*s)++;
		}
	return rval;
	}

TOKEN *getpat(char *arg)
	{
	int error;
	return makepat(arg, '\0', &error);
	}

#ifdef DEBUG1
insert(int ch, register char *str)
	{
	register char *bp;

	bp = str;
	while (*str)
		str++;
	do	{
		*(str + 1) = *str;
		str--;
		} while (bp <= str);
	*bp = ch;
	}
#endif

TOKEN *makepat(char *arg, int delim, int *error)
	{
	TOKEN *head = NULL, *tail = NULL;
	TOKEN *ntok;
	int i;

	*error = 0;
	if (*arg == '\0' || *arg == delim || *arg == '\n' || *arg == CLOSURE)
		{
		if (*arg == CLOSURE)
			*error = ERR_CLOSE;
		else
			*error = ERR_EMPTY;
		return NULL;
		}
	for (; *arg && *arg != delim && *arg != '\n' && !*error; arg++)
		{
		if ((ntok = (TOKEN *)malloc(sizeof(TOKEN))) == NULL)
			{
			*error = ERR_MEMORY;
			break;
			}
		switch (*arg)
			{
		case ANY:
			ntok->tok = ANY;
			break;
		case BOL:
			if (head == NULL)
				ntok->tok = BOL;
			else
				*error = ERR_BOL;
			break;	
		case EOL:
			if (*(arg + 1) == delim || *(arg + 1) == '\0' || *(arg + 1) == '\n')
				ntok->tok = EOL;
			else
				*error = ERR_EOL;
			break;
		case CCL:
			if (*(arg + 1) == NEGATE)
				{
				ntok->tok = NCCL;
				arg += 2;
				}
			else
				{
				ntok->tok = CCL;
				arg++;
				}
			if ((ntok->bitmap = (char *)malloc(16)) != NULL)
				{
				if ((arg = dodash(CCLEND, arg, ntok->bitmap)) == NULL)
					*error = ERR_UNMATCH;
				}
			else
				*error = ERR_MEMORY;
			break;
		case CLOSURE:
			switch (tail->tok)
				{
			case BOL:
			case EOL:
			case CLOSURE:
				*error = ERR_CLOSE;
				return NULL;
			default:
				ntok->tok = CLOSURE;
				break;
				}
			break;
		default:
			ntok->tok = LITCHAR;
			ntok->lchar = esc(&arg);
			--arg;
			}
		if (*error)
			{
			unmakepat(head);
			return NULL;
			}
		else if (head == NULL)
			{
			ntok->next = NULL;
			head = tail = ntok;
			}
		else if (ntok->tok != CLOSURE)
			{
			tail->next = ntok;
			ntok->next = tail;
			tail = ntok;
			}
		else if (head != tail)
			{
			(tail->next)->next = ntok;
			ntok->next = tail;
			}
		else
			{
			ntok->next = head;
			tail->next = ntok;
			head = ntok;
			}
		}
	tail->next = NULL;
	return head;
	}

char *matchs(char *line, TOKEN *pat, int ret_endp)
	{
	char *rval, *bptr;
	
	bptr = line;
	while (*line)
		{
		if ((rval = amatch(line, pat, bptr)) == NULL)
			line++;
		else
			{
			rval = ret_endp ? rval : line;
			break;
			}
		}
	return rval;
	}

char *stoupper(char *str)
	{
	char *rval;

	rval = str;
	while (*str)
			{
			*str = toupper(*str);
			str++;
			}
	return rval;
	}

int omatch(char **linp, TOKEN *pat, char *boln)
	{
	register int advance = -1;

	if (**linp)
		{
		switch (pat->tok)
			{
		case LITCHAR:
			if (**linp == pat->lchar)
				advance = 1;
			break;
		case BOL:
			if (*linp == boln)
				advance = 0;
			break;
		case ANY:
			if (**linp != '\n')
				advance = 1;
			break;
		case EOL:
			if (**linp == '\n')
				advance = 0;
			break;
		case CCL:
			if (testbit(**linp, pat->bitmap))
				advance = 1;
			break;
		case NCCL:
			if (!testbit(**linp, pat->bitmap))
				advance = 1;
			break;
		default:
			eprint("omatch: can't happen\n");
			}
		}
	if (0 < advance)
		*linp += advance;
	return ++advance;
	}

#ifdef DEBUG1
pr_line(register char *ln)
	{
	for (; *ln; ln++)
		{
		if ((' ' <= *ln) && (*ln <= '~'))
			putchar(*ln);
		else
			{
			print("\\0x%02x", *ln);
			if (*ln == '\n')
				putchar('\n');
			}
		}
	}

pr_tok(TOKEN *head)
	{
	register char *str;
	register int i;

	for (; head; head = head->next)
		{
		switch (head->tok)
			{
		case BOL:
			str = "BOL";
			break;
		case EOL:
			str = "EOL";
			break;
		case ANY:
			str = "ANY";
			break;
		case LITCHAR:
			str = "LITCHAR";
			break;
		case ESCAPE:
			str = "ESCAPE";
			break;
		case CCL:
			str = "CCL";
			break;
		case CCLEND:
			str = "CCLEND";
			break;
		case NCCL:
			str = "NCCL";
			break;
		case CLOSURE:
			str = "CLOSURE";
			break;
		default:
			str = "**** unknown ****";
			}
		print("%-8s: at 0x%x, ", str, head);
		if (head->tok == CCL || head->tok == NCCL)
			{
			print("string (at 0x%x) =<", head->bitmap);
			for (i = 0; i < 0x7f; i++)
				if (testbit(i, head->bitmap))
					putchar(i);
			print(">, ");
			}
		else if (head->tok == LITCHAR)
			print("lchar = %c, ", head->lchar);
		print("next = 0x%x\n", head->next);
		}
	putchar('\n');
	}
#endif

unmakepat(TOKEN *head)
	{
	register TOKEN *old_head;

	while (head)
		{
		switch (head->tok)
			{
		case CCL:
		case NCCL:
			free(head->bitmap);
			}
		old_head = head;
		head = head->next;
		free(old_head);
		}
	}

char *index(char c, char *str)
	{
	while (*str)
		if (*str++ == c)
			return str;
	return NULL;
	}
			
